// TASCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TASC.h"
#include "TASCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTASCDlg dialog

CTASCDlg::CTASCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTASCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTASCDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTASCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTASCDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTASCDlg, CDialog)
	//{{AFX_MSG_MAP(CTASCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_TASERVER, OnTaserver)
	ON_BN_CLICKED(IDC_BNETSERVER, OnBnetserver)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTASCDlg message handlers

BOOL CTASCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//Set the first radio button checked
	CButton* pServerType = (CButton*)GetDlgItem(IDC_BNETSERVER);
	pServerType->SetCheck(TRUE);

	//Gray out the IP Address box
	CEdit* pIPAddress = (CEdit *)GetDlgItem(IDC_IPADDRESS);
	pIPAddress->SetReadOnly(TRUE);

	//Set launch to checked
	CButton* pLaunch = (CButton*)GetDlgItem(IDC_LAUNCH);
	pLaunch->SetCheck(TRUE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTASCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTASCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTASCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTASCDlg::OnOK() 
{
	// TODO: Add extra validation here
	//First Get the server type	
	CButton* pServerType = (CButton *)GetDlgItem(IDC_TASERVER);
	m_serverType = pServerType->GetCheck();

	if(m_serverType) //Other Server?  If so get the address.
	{
		CEdit* pIPAddress = (CEdit *)GetDlgItem(IDC_IPADDRESS);
		pIPAddress->GetWindowText(m_ipAddress);
	}

	//Finally get the autolaunch
	CButton* pLaunch = (CButton*)GetDlgItem(IDC_LAUNCH);
	m_launch = pLaunch->GetCheck();

	if(m_launch)
	{
		int size;
		HKEY key;

		if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\Blizzard Entertainment\\Starcraft", 0, KEY_READ, &key)==ERROR_SUCCESS)
		{
			RegQueryValueEx(key, "Program", NULL, NULL, NULL, (unsigned long *)&size);
			m_program = new char[size + 1];
			
			RegQueryValueEx(key, "Program", NULL, NULL, (unsigned char *)m_program, (unsigned long *)&size);
		}
	}
	
	CDialog::OnOK();
}

void CTASCDlg::OnTaserver() 
{
	// TODO: Add your control notification handler code here
	
	//Enable the IP Address box
	CEdit* pIPAddress = (CEdit *)GetDlgItem(IDC_IPADDRESS);
	pIPAddress->SetReadOnly(FALSE);
}

void CTASCDlg::OnBnetserver() 
{
	// TODO: Add your control notification handler code here

	//Gray out the IP Address box
	CEdit* pIPAddress = (CEdit *)GetDlgItem(IDC_IPADDRESS);
	pIPAddress->SetReadOnly(TRUE);
}
